'*****************************************************************
'*                                                               *
'* Software pro 8x Ir detektor priblizeni s I2C slave rozhranim  *
'*                                                               *
'* Autor: Jan Babjak (jan@babjak.cz)  last edit: 03.04.2006      *
'*                                                               *
'* web: ir.babjak.cz                                             *
'*                                                               *
'*****************************************************************


$crystal = 8000000
$regfile = "m8def.dat"


Const I2c_slave_address = &B01110001

' Pocet po sobe stejnych namerenych hodnot, aby byla data platna
Const Pocet_mereni = 4

' Pocet mikropulzu pro vyvvoreni jednoho pulsu na IR diode
Const Micropulse_pulse = 30


' casy PWM jedotlivzch urovni svitu diody
Const Time_high_on = 12
Const Time_high_off = 12

Const Time_med_on = 6
Const Time_med_off = 18

Const Time_low_on = 2
Const Time_low_off = 22


' Konfigurace portu

Config Pind.0 = Output                                      ' GREEN_LED
Green_led Alias Portd.0
Config Pinc.3 = Output                                      ' RED_LED
Red_led Alias Portc.3

Config Pind.7 = Output                                      ' IRE0
Ire0 Alias Portd.7
Config Pinb.0 = Input                                       ' IRR0
Irr0 Alias Pinb.0

Config Pind.6 = Output                                      ' IRE1
Ire1 Alias Portd.6
Config Pind.5 = Input                                       ' IRR1
Irr1 Alias Pind.5

Config Pind.2 = Output                                      ' IRE2
Ire2 Alias Portd.2
Config Pind.4 = Input                                       ' IRR2
Irr2 Alias Pind.4

Config Pind.3 = Output                                      ' IRE3
Ire3 Alias Portd.3
Config Pind.1 = Input                                       ' IRR3
Irr3 Alias Pind.1

Config Pinb.1 = Output                                      ' IRE4
Ire4 Alias Portb.1
Config Pinb.3 = Input                                       ' IRR4
Irr4 Alias Pinb.3

Config Pinb.2 = Output                                      ' IRE5
Ire5 Alias Portb.2
Config Pinb.4 = Input                                       ' IRR5
Irr5 Alias Pinb.4

Config Pinc.2 = Output                                      ' IRE6
Ire6 Alias Portc.2
Config Pinb.5 = Input                                       ' IRR6
Irr6 Alias Pinb.5

Config Pinc.1 = Output                                      ' IRE7
Ire7 Alias Portc.1
Config Pinc.0 = Input                                       ' IRR7
Irr7 Alias Pinc.0


' Deklarace promennych

Dim Tw_status As Byte
Dim Tw_address_eram As Eram Byte
Dim Tw_address As Byte
Dim I As Byte

Dim Detekce As Byte

Dim Tw_data As Byte
Dim Tw_sr As Byte

Dim Data_high As Byte
Dim Data_med As Byte
Dim Data_low As Byte

Dim Prekazka0_high As Byte
Dim Prekazka0_med As Byte
Dim Prekazka0_low As Byte

Dim Prekazka1_high As Byte
Dim Prekazka1_med As Byte
Dim Prekazka1_low As Byte

Dim Prekazka2_high As Byte
Dim Prekazka2_med As Byte
Dim Prekazka2_low As Byte

Dim Prekazka3_high As Byte
Dim Prekazka3_med As Byte
Dim Prekazka3_low As Byte

Dim Prekazka4_high As Byte
Dim Prekazka4_med As Byte
Dim Prekazka4_low As Byte

Dim Prekazka5_high As Byte
Dim Prekazka5_med As Byte
Dim Prekazka5_low As Byte

Dim Prekazka6_high As Byte
Dim Prekazka6_med As Byte
Dim Prekazka6_low As Byte

Dim Prekazka7_high As Byte
Dim Prekazka7_med As Byte
Dim Prekazka7_low As Byte

Dim Med_send As Byte

Dim New_address As Byte

On Twi I2cint




' nacteni I2C slave adresy z eeprom
New_address = I2c_slave_address
If Tw_address_eram = &HFF Then Tw_address = New_address Else Tw_address = Tw_address_eram

' Inicializace TWI

Twar = Tw_address
Twcr.twen = 1
Twcr.twie = 0
Twcr.twint = 0
Twcr.twea = 0
Twcr.twsta = 0
Twcr.twsto = 0
Twcr.twwc = 0

Twcr.twen = 1
Twcr.twie = 1
Twcr.twint = 1
Twcr.twea = 1
Twcr.twsta = 0
Twcr.twsto = 0
Twcr.twwc = 0


'Inicializace promennych


Prekazka0_high = 0
Prekazka0_med = 0
Prekazka0_low = 0

Prekazka1_high = 0
Prekazka1_med = 0
Prekazka1_low = 0

Prekazka2_high = 0
Prekazka2_med = 0
Prekazka2_low = 0

Prekazka3_high = 0
Prekazka3_med = 0
Prekazka3_low = 0

Prekazka4_high = 0
Prekazka4_med = 0
Prekazka4_low = 0

Prekazka5_high = 0
Prekazka5_med = 0
Prekazka5_low = 0

Prekazka6_high = 0
Prekazka6_med = 0
Prekazka6_low = 0

Prekazka7_high = 0
Prekazka7_med = 0
Prekazka7_low = 0


' Bliknuti LEDkami po zapnuti
Red_led = 0
Green_led = 0
Waitms 200
Red_led = 1
Green_led = 1



Enable Interrupts



' hlavni programova smycka
Do

'---------------------------------- Sensor 00 ----------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire0 = 0
    Waitus Time_high_on
    Ire0 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr0
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr0 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka0_high <> Pocet_mereni Then Incr Prekazka0_high Else Data_high.0 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire0 = 0
      Waitus Time_med_on
      Ire0 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr0
    Waitms 1

    If Detekce = 0 And Irr0 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka0_med <> Pocet_mereni Then Incr Prekazka0_med Else Data_med.0 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire0 = 0
        Waitus Time_low_on
        Ire0 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr0
      Waitms 1

      If Detekce = 0 And Irr0 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka0_low <> Pocet_mereni Then Incr Prekazka0_low Else Data_low.0 = 1
      Else
        If Prekazka0_low <> 0 Then Decr Prekazka0_low Else Data_low.0 = 0
      End If
    Else
      If Prekazka0_med <> 0 Then Decr Prekazka0_med Else Data_med.0 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka0_high <> 0 Then Decr Prekazka0_high Else Data_high.0 = 0
    If Prekazka0_med <> 0 Then Decr Prekazka0_med Else Data_med.0 = 0
    If Prekazka0_low <> 0 Then Decr Prekazka0_low Else Data_low.0 = 0

  End If
  Waitus 10

'-------------------------------------- Sensor 1 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire1 = 0
    Waitus Time_high_on
    Ire1 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr1
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr1 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka1_high <> Pocet_mereni Then Incr Prekazka1_high Else Data_high.1 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire1 = 0
      Waitus Time_med_on
      Ire1 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr1
    Waitms 1

    If Detekce = 0 And Irr1 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka1_med <> Pocet_mereni Then Incr Prekazka1_med Else Data_med.1 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire1 = 0
        Waitus Time_low_on
        Ire1 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr1
      Waitms 1

      If Detekce = 0 And Irr1 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka1_low <> Pocet_mereni Then Incr Prekazka1_low Else Data_low.1 = 1
      Else
        If Prekazka1_low <> 0 Then Decr Prekazka1_low Else Data_low.1 = 0
      End If
    Else
      If Prekazka1_med <> 0 Then Decr Prekazka1_med Else Data_med.1 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka1_high <> 0 Then Decr Prekazka1_high Else Data_high.1 = 0
    If Prekazka1_med <> 0 Then Decr Prekazka1_med Else Data_med.1 = 0
    If Prekazka1_low <> 0 Then Decr Prekazka1_low Else Data_low.1 = 0

  End If
  waitus 10

'-------------------------------------- Sensor 2 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire2 = 0
    Waitus Time_high_on
    Ire2 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr2
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr2 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka2_high <> Pocet_mereni Then Incr Prekazka2_high Else Data_high.2 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire2 = 0
      Waitus Time_med_on
      Ire2 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr2
    Waitms 1

    If Detekce = 0 And Irr2 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka2_med <> Pocet_mereni Then Incr Prekazka2_med Else Data_med.2 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire2 = 0
        Waitus Time_low_on
        Ire2 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr2
      Waitms 1

      If Detekce = 0 And Irr2 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka2_low <> Pocet_mereni Then Incr Prekazka2_low Else Data_low.2 = 1
      Else
        If Prekazka2_low <> 0 Then Decr Prekazka2_low Else Data_low.2 = 0
      End If
    Else
      If Prekazka2_med <> 0 Then Decr Prekazka2_med Else Data_med.2 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka2_high <> 0 Then Decr Prekazka2_high Else Data_high.2 = 0
    If Prekazka2_med <> 0 Then Decr Prekazka2_med Else Data_med.2 = 0
    If Prekazka2_low <> 0 Then Decr Prekazka2_low Else Data_low.2 = 0

  End If
  waitus 10

'-------------------------------------- Sensor 3 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire3 = 0
    Waitus Time_high_on
    Ire3 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr3
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr3 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka3_high <> Pocet_mereni Then Incr Prekazka3_high Else Data_high.3 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire3 = 0
      Waitus Time_med_on
      Ire3 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr3
    Waitms 1

    If Detekce = 0 And Irr3 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka3_med <> Pocet_mereni Then Incr Prekazka3_med Else Data_med.3 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire3 = 0
        Waitus Time_low_on
        Ire3 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr3
      Waitms 1

      If Detekce = 0 And Irr3 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka3_low <> Pocet_mereni Then Incr Prekazka3_low Else Data_low.3 = 1
      Else
        If Prekazka3_low <> 0 Then Decr Prekazka3_low Else Data_low.3 = 0
      End If
    Else
      If Prekazka3_med <> 0 Then Decr Prekazka3_med Else Data_med.3 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka3_high <> 0 Then Decr Prekazka3_high Else Data_high.3 = 0
    If Prekazka3_med <> 0 Then Decr Prekazka3_med Else Data_med.3 = 0
    If Prekazka3_low <> 0 Then Decr Prekazka3_low Else Data_low.3 = 0

  End If
  waitus 10

'-------------------------------------- Sensor 4 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire4 = 0
    Waitus Time_high_on
    Ire4 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr4
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr4 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka4_high <> Pocet_mereni Then Incr Prekazka4_high Else Data_high.4 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire4 = 0
      Waitus Time_med_on
      Ire4 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr4
    Waitms 1

    If Detekce = 0 And Irr4 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka4_med <> Pocet_mereni Then Incr Prekazka4_med Else Data_med.4 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire4 = 0
        Waitus Time_low_on
        Ire4 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr4
      Waitms 1

      If Detekce = 0 And Irr4 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka4_low <> Pocet_mereni Then Incr Prekazka4_low Else Data_low.4 = 1
      Else
        If Prekazka4_low <> 0 Then Decr Prekazka4_low Else Data_low.4 = 0
      End If
    Else
      If Prekazka4_med <> 0 Then Decr Prekazka4_med Else Data_med.4 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka4_high <> 0 Then Decr Prekazka4_high Else Data_high.4 = 0
    If Prekazka4_med <> 0 Then Decr Prekazka4_med Else Data_med.4 = 0
    If Prekazka4_low <> 0 Then Decr Prekazka4_low Else Data_low.4 = 0

  End If
  waitus 10

'-------------------------------------- Sensor 5 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire5 = 0
    Waitus Time_high_on
    Ire5 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr5
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr5 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka5_high <> Pocet_mereni Then Incr Prekazka5_high Else Data_high.5 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire5 = 0
      Waitus Time_med_on
      Ire5 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr5
    Waitms 1

    If Detekce = 0 And Irr5 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka5_med <> Pocet_mereni Then Incr Prekazka5_med Else Data_med.5 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire5 = 0
        Waitus Time_low_on
        Ire5 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr5
      Waitms 1

      If Detekce = 0 And Irr5 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka5_low <> Pocet_mereni Then Incr Prekazka5_low Else Data_low.5 = 1
      Else
        If Prekazka5_low <> 0 Then Decr Prekazka5_low Else Data_low.5 = 0
      End If
    Else
      If Prekazka5_med <> 0 Then Decr Prekazka5_med Else Data_med.5 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka5_high <> 0 Then Decr Prekazka5_high Else Data_high.5 = 0
    If Prekazka5_med <> 0 Then Decr Prekazka5_med Else Data_med.5 = 0
    If Prekazka5_low <> 0 Then Decr Prekazka5_low Else Data_low.5 = 0

  End If
  waitus 10

'-------------------------------------- Sensor 6 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire6 = 0
    Waitus Time_high_on
    Ire6 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr6
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr6 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka6_high <> Pocet_mereni Then Incr Prekazka6_high Else Data_high.6 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire6 = 0
      Waitus Time_med_on
      Ire6 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr6
    Waitms 1

    If Detekce = 0 And Irr6 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka6_med <> Pocet_mereni Then Incr Prekazka6_med Else Data_med.6 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire6 = 0
        Waitus Time_low_on
        Ire6 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr6
      Waitms 1

      If Detekce = 0 And Irr6 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka6_low <> Pocet_mereni Then Incr Prekazka6_low Else Data_low.6 = 1
      Else
        If Prekazka6_low <> 0 Then Decr Prekazka6_low Else Data_low.6 = 0
      End If
    Else
      If Prekazka6_med <> 0 Then Decr Prekazka6_med Else Data_med.6 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka6_high <> 0 Then Decr Prekazka6_high Else Data_high.6 = 0
    If Prekazka6_med <> 0 Then Decr Prekazka6_med Else Data_med.6 = 0
    If Prekazka6_low <> 0 Then Decr Prekazka6_low Else Data_low.6 = 0

  End If
  waitus 10

'-------------------------------------- Sensor 7 ---------------------------------------

  ' nasleduje vytvoreni serie pulsu prislusne diody
  For I = 1 To Micropulse_pulse
    Ire7 = 0
    Waitus Time_high_on
    Ire7 = 1
    Waitus Time_high_off
  Next I

  Detekce = Irr7
  ' zjisteni stavu na senzoru

  Waitms 1
  ' cekani pred opetovnym zjistenim stavu

  If Detekce = 0 And Irr7 = 1 Then
    ' byla detekovana prekazka v urovni HIGH
    If Prekazka7_high <> Pocet_mereni Then Incr Prekazka7_high Else Data_high.7 = 1

    ' nyni se provede mereni pro uroven MED
    For I = 1 To Micropulse_pulse
      Ire7 = 0
      Waitus Time_med_on
      Ire7 = 1
      Waitus Time_med_off
    Next I

    Detekce = Irr7
    Waitms 1

    If Detekce = 0 And Irr7 = 1 Then
      ' byla detekovana prekazka v urovni MED
      If Prekazka7_med <> Pocet_mereni Then Incr Prekazka7_med Else Data_med.7 = 1

      ' nyni se provede mereni pro uroven LOW
      For I = 1 To Micropulse_pulse
        Ire7 = 0
        Waitus Time_low_on
        Ire7 = 1
        Waitus Time_low_off
      Next I

      Detekce = Irr7
      Waitms 1

      If Detekce = 0 And Irr7 = 1 Then
        ' byla detekovana prekazka v urovni LOW
        If Prekazka7_low <> Pocet_mereni Then Incr Prekazka7_low Else Data_low.7 = 1
      Else
        If Prekazka7_low <> 0 Then Decr Prekazka7_low Else Data_low.7 = 0
      End If
    Else
      If Prekazka7_med <> 0 Then Decr Prekazka7_med Else Data_med.7 = 0
    End If

  Else
    ' nebyla detekovana prekazka v urovni HIGH
    If Prekazka7_high <> 0 Then Decr Prekazka7_high Else Data_high.7 = 0
    If Prekazka7_med <> 0 Then Decr Prekazka7_med Else Data_med.7 = 0
    If Prekazka7_low <> 0 Then Decr Prekazka7_low Else Data_low.7 = 0

  End If
  waitus 10

'----------------------------------------- Final ---------------------------------------

  If Data_high > 0 Then Red_led = 0 Else Red_led = 1



Loop


'--------------------------------- I2C Slave diriver -----------------------------------


I2cint:
' obsluha preruseni Two Wire Interface, zde se zpracovavaji vsechny podnety z TWI.

  Select Case Twsr
    Case &HA8:
    ' Own SLA+R has been recieved, ACK has been returned
      ' Bylo detekovano prijeti SLA+R, obvod se pripravi na vyslani namerenych dat
      ' priprava vyslani prvniho bajtu zpravy
      Twdr = Data_high
      Med_send = 0
      Twcr.twen = 1
      Twcr.twie = 1
      Twcr.twint = 1
      Twcr.twea = 1
      Twcr.twsta = 0
      Twcr.twsto = 0
      Twcr.twwc = 0

    Case &HB8
    ' Data byte in TWDR has been transmitted, ACK has been recieved
      ' priprava vyslani druheho bajtu zpravy
      If Med_send = 0 Then
        Twdr = Data_med
        Med_send = 1
      Else
        Twdr = Data_low
      End If


      Twcr.twen = 1
      Twcr.twie = 1
      Twcr.twint = 1
      Twcr.twea = 1
      Twcr.twsta = 0
      Twcr.twsto = 0
      Twcr.twwc = 0

    Case &HC0:
    ' Data byte in TWDR has been transmitted, NOT ACK has been recieved
      ' Byly odeslany namerene data, komunikace se ukonci a TWI se prepne
      ' do vychoziho nastaveni, kdy sleduje sbernici a ceka na svou adresu.
      Twcr.twen = 1
      Twcr.twie = 1
      Twcr.twint = 1
      Twcr.twea = 1
      Twcr.twsta = 0
      Twcr.twsto = 0

      Green_led = Not Green_led


    Case &H70:
    ' General call has been recieved, ACK has been returned
      ' Byl detekovan Generall Call. Obvod se pripravi na prijeti jednoho byte
      Twdr = 0
      Twcr.twen = 1
      Twcr.twie = 1
      Twcr.twint = 1
      Twcr.twea = 0
      Twcr.twsta = 0
      Twcr.twsto = 0
      Twcr.twwc = 0

    Case &H98:
    ' Prewiously addressed with generall call; data has been recieved. NOT ACK has been returned
      ' Zde se skoci, kdyz byla prijata data po detekci Generall Call a ulozena do TWDR
      ' nejvyssich sedm bit bude pouzito jako nova adresa TWI Atmelu.
      Twcr.twen = 1
      Twcr.twie = 1
      Twcr.twint = 1
      Twcr.twea = 1
      Twcr.twsta = 0
      Twcr.twsto = 0
      Twcr.twwc = 0

      Tw_address_eram = Twdr


    Case &HA0:
    ' STOP condition or repeated START condition has been recieved whille still addressed as Slave
      ' ukonceni session na I2C sbernici. TWI se prepne do stavu
      ' kdy opet sleduje provoz a reaguje na zpravy pro nej urcene.
      Twcr.twen = 1
      Twcr.twie = 1
      Twcr.twint = 1
      Twcr.twea = 1
      Twcr.twsta = 1
      Twcr.twsto = 0
      Twcr.twwc = 0

  End Select

Return

' by JayBee